# -*- coding: utf-8 -*-
##------------------------------------------
##  Japanese speaking program  Ver 0.01
##       by Open JTalk platform: linux
##
##               2022.09.13 Masahiro Izutsu
##------------------------------------------
## jtalk.py

import subprocess
from datetime import datetime

HTS_VOICE = ['mei/mei_normal.htsvoice',
             'nitech-jp-atr503-m001/nitech_jp_atr503_m001.htsvoice',
             'mei/mei_angry.htsvoice',
             'mei/mei_bashful.htsvoice',
             'mei/mei_happy.htsvoice',
             'mei/mei_sad.htsvoice'
             ]

def jtalk(t, voice = 0, waitf = False):
    open_jtalk=['open_jtalk']
    mech=['-x','/var/lib/mecab/dic/open-jtalk/naist-jdic']
    htsvoice=['-m','/usr/share/hts-voice/' + HTS_VOICE[voice]]
    speed=['-r','1.0']
    outwav=['-ow','open_jtalk.wav']
    cmd=open_jtalk+mech+htsvoice+speed+outwav
    c = subprocess.Popen(cmd,stdin=subprocess.PIPE)
    c.stdin.write(t.encode())
    c.stdin.close()
    c.wait()
    aplay = ['aplay','-q','open_jtalk.wav']
    wr = subprocess.Popen(aplay)
    if waitf:
        wr.wait()

def say_datetime(voice = 0, waitf = False):
    d = datetime.now()
    text = '%s月%s日、%s時%s分%s秒' % (d.month, d.day, d.hour, d.minute, d.second)
    jtalk(text, voice, waitf)

if __name__ == '__main__':
    import sys

    args = sys.argv
    sel = '0' if len(args) <= 1 else args[1]
    voice = int(sel)
    if voice >= len(HTS_VOICE):
        voice = 0

    jtalk(u'オープンジェイトークを使用して日本語を話します', voice, True) 
    say_datetime(voice)

